//--------------------------------------------------------------------------------
// constant
//--------------------------------------------------------------------------------
const float  fPI=3.141593f;
const float  fRD=6.2831853f;
const double dPI=3.141592653589793;
const double dRD=6.2831853071795865;





//--------------------------------------------------------------------------------
// Log2
//--------------------------------------------------------------------------------
int calc2N(int i)
{
    int n;
    for (n=1; n<i;) { n<<=1; }
    return n;
}


int calcLog2(int i)
{
    int n;
    for (n=-1; i!=0; n++) { i>>=1; }
    return n;
}




//--------------------------------------------------------------------------------
// Exchange
//--------------------------------------------------------------------------------
float ubyte2float(ubyte b) { return cast(float)(b*0.0039215686f); }
ubyte float2ubyte(float f) { return cast(ubyte)(f*255.0f+0.5f); }

double ubyte2double(ubyte  b) { return cast(double)(b*0.0039215686); }
ubyte  double2ubyte(double f) { return cast(ubyte)(f*255.0+0.5); }

double degree2radian(double d) { return d * 0.01745329251994330; }
double radian2degree(double d) { return d * 57.295779513082321; }




//--------------------------------------------------------------------------------
// max/min
//--------------------------------------------------------------------------------
T min(T)(T t0, T t1) { return (t0<t1)?t0:t1; }
T max(T)(T t0, T t1) { return (t0>t1)?t0:t1; }
T limit(T)(T t0, T tmin, T tmax) { return (t0>tmin)?(t0<tmax)?t0:tmax:tmin; }
void sort3(T)(out T tmin, out T tmid, out T tmax, T t0, T t1, T t2) {
    if (t0<=t1) {
        if (t1<=t2) {
            tmin = t0;
            tmid = t1;
            tmax = t2;
        } else {
            tmax = t1;
            if (t0<=t2) {
                tmin = t0;
                tmid = t2;
            } else {
                tmin = t2;
                tmid = t0;
            }
        }
    } else {
        if (t1>=t2) {
            tmin = t2;
            tmid = t1;
            tmax = t0;
        } else {
            tmin = t1;
            if (t0<=t2) {
                tmid = t0;
                tmax = t2;
            } else {
                tmid = t2;
                tmax = t0;
            }
        }
    }
}
